<?php
/*----------------------------------------------------------------------------\
|                  JAF CMS - ...just another flat file CMS                    |
|-----------------------------------------------------------------------------|
|-----------------------------------------------------------------------------|
|                        Created by Salim "ph03y3nk"                          |
|               (Mail Contact : ph03y3nk@users.sourceforge.net)               |
|                For JAF CMS (http://jaf-cms.sourceforge.net/)                |
|-----------------------------------------------------------------------------|
|-----------------------------------------------------------------------------|
| JAF CMS - ...just another flat file CMS, is a Simple PHP Content Management |
| System (CMS). Consist of a powerfull set of PHP scripts, for small personal |
| homepage without database needed. Tested on Apache server 1.3.23 and PHP 4. |
|-----------------------------------------------------------------------------|
|-----------------------------------------------------------------------------|
|                   Copyright (c) 2004, Salim,SE. (ph03y3nk)                  |
|                                                                             |
|                             ___            ___                              |
|                            /\__\          /\__\                             |
|                           /:/ _/_        /:/ _/_                            |
|                          /:/ /\  \      /:/ /\  \                           |
|                         /:/ /::\  \    /:/ /::\  \                          |
|                        /:/_/:/\:\__\  /:/_/:/\:\__\                         |
|                        \:\/:/ /:/  /  \:\/:/ /:/  /                         |
|                         \::/ /:/  /    \::/ /:/  /                          |
|                          \/_/:/  /      \/_/:/  /                           |
|                            /:/  /         /:/  /                            |
|                            \/__/July,2004.\/__/                             |
|                             -Salims Softhouse-                              |
|                                                                             |
|-----------------------------------------------------------------------------|
|-----------------------------------------------------------------------------|
| This software is provided "as is", without warranty of any kind, express or |
| implied, including  but not limited  to the warranties of  merchantability, |
| fitness for a particular purpose and noninfringement. In no event shall the |
| authors or  copyright  holders be  liable for any claim,  damages or  other |
| liability, whether  in an  action of  contract, tort  or otherwise, arising |
| from,  out of  or in  connection with  the software or  the  use  or  other |
| dealings in the software.                                                   |
| - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - |
| This  software is  available under GNU GPL - The GNU General Public License |
| v2.  To use this software you must accept the license terms and conditions. |
| - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - |
| GPL - The GNU General Public License    http://www.gnu.org/licenses/gpl.txt |
| Permits anyone the right to use and modify the software without limitations |
| as long as proper  credits are given  and the original  and modified source |
| code are included. Requires  that the final product, software derivate from |
| the original  source or any  software  utilizing a GPL  component, such  as |
| this, is also licensed under the GPL license.                               |
| - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - |
| You should have received a copy of the GNU General Public License along     |
| with this program, if not, write to the Free Software Foundation, Inc., 59  |
| Temple Place, Suite 330, Boston, MA 02111-1307 USA                          |
|-----------------------------------------------------------------------------|
|-----------------------------------------------------------------------------|
| Created 04/05/2006 |-----------------------------------| Updated 09/05/2006 |
\----------------------------------------------------------------------------*/

/* Generates RSS/XML data feed as part of the JAF-CMS site syndication */

// disable browser caching to keep the webpage up to date
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");

include('config.php');

extract($_GET);
global $feed, $feed_ver;
$RSS = new RSS;

if(isset ($_GET['feed'])){
    switch ($_GET['feed']) {
        case '0.91':
            $feed_ver = '0.91';
            break;
        case '1.0':
            $feed_ver = '1.0';
            break;
        default:
            $feed_ver = '2.0';
    }
}
else {
    $feed_ver = '2.0';
}


// possible hacks, if u wanna use your own XSL templates !!!
// leave it empty then it will display only XML data tree
// on your browser, except for RSS version 1.0(rdf) it will
// use default style from World Wide Web Consortium (www.w3.org)
//---------------------------------------------------------------

if ($feed_ver == '1.0'){
    $RSS->xslStyleSheet = './templates/rss_feeds/rdf.xsl';
}
else {
    $RSS->xslStyleSheet = './templates/rss_feeds/rss.xsl';
}


// perhaps u don't need to change anything below this line
//---------------------------------------------------------------

$RSS->versionRSS = $feed_ver;
$RSS->channelTitle = $title . ' - site syndication';
$RSS->channelLink = $site;
$RSS->channelDescription = $description;
$RSS->channelLanguage = 'en-us';
$RSS->channelCopyright = 'Copyright 2006 - ' .$web_author;
$RSS->channelWebmaster = $webmaster_mail;
$RSS->channellastBuildDate = date("D, d M Y H:i:s O");          // RFC 822 formatted date
$RSS->channelGenerator = 'JAF-CMS engine v4.0';

$xmlData = $RSS->Create();

// Output the generated RSS XML
//---------------------------------------------------------------

header("Content-type: text/xml");
echo $xmlData;


// here is PHP class for JAF-CMS RSS Feed Generator
// it will crawl your data directory and generating xml output
//---------------------------------------------------------------

class RSS {
    // Create channel variables
    var $xslStyleSheet;
    var $cssStyleSheet;
    var $versionRSS;
    var $channelTitle;
    var $channelLink;
    var $channelDesc;
    var $channelLanguage;
    var $channelCopyright;
    var $channelWebmaster;
    var $channellastBuildDate;
    var $channelGenerator;

    function _createStylesheetReferences() {
        // if defined style exist it will add xml stylesheet refference to our feeds

        $xmlValue = "";
        if ($this->xslStyleSheet) $xmlValue .= "<?xml-stylesheet href=\"".$this->xslStyleSheet."\" type=\"text/xsl\"?>\n";
        if ($this->cssStyleSheet) $xmlValue .= "<?xml-stylesheet href=\"".$this->cssStyleSheet."\" type=\"text/css\"?>\n";
        return $xmlValue;
    }
    
    function Create () {
        global $xslStyleSheet, $cssStyleSheet, $feed_ver, $xmlValue, $site, $title, $description, $web_author, $webmaster_mail;

        $xmlValue .= "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n\n";
        $xmlValue .= "<!--\nThis is an RSS feed from the JAF-CMS powered website.\nGenerated by " . $this->channelGenerator . "\n-->\n";
        
        // check RSS feed version request, wether it is RSS0.91, RSS1.0(rdf), or RSS2.0
        // then creating the output
        
        if ($this->versionRSS === '1.0') {
            // for version 1.0 outputing rdf format
            //--------------------------------------------------------------
            // if there is no stylesheet define to format xml feeds, then try to
            // use default basic stylesheet from World Wide Web Consortium (http://www.w3.org).
        
    		if ($this->xslStyleSheet=='') {
    			$this->cssStyleSheet = "http://www.w3.org/2000/08/w3c-synd/style.css";
    		}
            $xmlValue .= $this->_createStylesheetReferences();
            $xmlValue .= "<rdf:RDF\n";
            $xmlValue .= "   xmlns=\"http://purl.org/rss/1.0/\"\n";
            $xmlValue .= "   xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\"\n";
            $xmlValue .= "   xmlns:slash=\"http://purl.org/rss/1.0/modules/slash/\"\n";
            $xmlValue .= "   xmlns:dc=\"http://purl.org/dc/elements/1.1/\">\n";
    
            // Build the channel tag
            $xmlValue .= "   <channel rdf:about=\"" . htmlspecialchars($this->channelLink) . "\">\n";
            $xmlValue .= "      <title>" . $this->channelTitle . "</title>\n";
            $xmlValue .= "      <description>" . htmlspecialchars($this->channelDescription) . "</description>\n";
            $xmlValue .= "      <link>" . htmlspecialchars($this->channelLink) . "</link>\n";
            $xmlValue .= "      <dc:date>" . $this->channellastBuildDate . "</dc:date>\n";
            $xmlValue .= "      <items>\n";
            $xmlValue .= "         <rdf:Seq>\n";
        
                // Connect to the database
                $list = opendir("./data/");
                $count=0;
                while($get_list = readdir($list)) {
                    if ($get_list != "." && $get_list != ".." && $get_list != ".htaccess") {
                        $xmlValue .= "            <rdf:li rdf:resource=\"" . htmlspecialchars($this->channelLink) . "/index.php?show=" . $get_list . "\" />\n";
                    $count++;
                    }
                }
                closedir($list);
        
            $xmlValue .= "         </rdf:Seq>\n";
            $xmlValue .= "      </items>\n";
            $xmlValue .= "   </channel>\n";
        
        
                $list2 = opendir("./data/");
                $count2=0;
                while($get_list2 = readdir($list2)) {
                    if ($get_list2 != "." && $get_list2 != ".." && $get_list2 != ".htaccess") {
        
                        $filename = "./data/". $get_list2;
                        $fileDate = filemtime($filename);
                        $fileModDate = date("D, d M Y H:i:s O",$fileDate);
                        $file = fopen ($filename, "r");
                        $buffer_size = 8192;
                        $summary = "";
        
                        $xmlValue .= "   <item rdf:about=\"" . htmlspecialchars($this->channelLink) . "/index.php?show=" . $get_list2 . "\">\n";
                        $xmlValue .= "      <title>" . $get_list2 . "</title>\n";
                        $xmlValue .= "      <description>";
        
                            // read data and striped html tag from it
                            while (!feof ($file)) {
                                $line = fgetss ($file, $buffer_size);

                                // shorten a string to a certain length (400 char) at the most sensible point.
                                // If the string is already shorter than 400 char, it is returned unchanged.
                                // else if the string is more than 400 char, then
                                // if there's a ' ' (space) character near the end of the string, 
                                // the string is truncated after the last ' ' character.
                                // If the string is truncated, "....." is appended.

                                if (strlen($line) <= 400) { 
                                    $summary .= $line;                  // already shorter than 400 char
                                }
                                else {
                                    //$summary .= substr_replace($line,'.....',400,($buffer_size));
                                    
                                    $pos = strrpos($line," ");
                                    if ($pos>=396) {
                                        $line = substr($line,0,396);
                                        $pos = strrpos($line," ");
                                    }
                                    if ($pos>=400*0.4) {
                                        $summary .= substr($line,0,$pos).".....";
                                        break;
                                    }
                                }
                            } 
        
                        $xmlValue .= htmlspecialchars($summary);
                        $xmlValue .= "</description>\n";
                        $xmlValue .= "      <link>" . htmlspecialchars($this->channelLink) . "/index.php?show=" . $get_list2 . "</link>\n";
                        //$xmlValue .= "      <dc:source>" . htmlspecialchars($this->channelLink) . "</dc:source>\n";
                        $xmlValue .= "      <dc:format>text/html</dc:format>\n";
                        $xmlValue .= "      <dc:date>" . $fileModDate . "</dc:date>\n";
                        $xmlValue .= "   </item>\n";
                    $count2++;
                    }
                }
                closedir($list2);
            // Add the closing rdf tag and return the value
            $xmlValue .= "</rdf:RDF>\n";
            
        }
        else {
        
            // outputing RSS version 0.91 or 2.0
            
            //$xmlValue .= "<!DOCTYPE rss PUBLIC \"-//Netscape Communications//DTD RSS 0.91//EN\"\n";
            //$xmlValue .= " \"http://my.netscape.com/publish/formats/rss-0.91.dtd\">\n";
            //--------------------------------------------------------------
            // if there is no stylesheet define to format xml feeds,
            // it will show only the xml data tree.

            $xmlValue .= $this->_createStylesheetReferences();
            $xmlValue .= "<rss version=\"" . $this->versionRSS . "\">\n";

            // Build the channel tag
            $xmlValue .= "  <channel>\n";
            $xmlValue .= "      <title>" . $this->channelTitle . "</title>\n";
            $xmlValue .= "      <description>" . htmlspecialchars($this->channelDescription) . "</description>\n";
            $xmlValue .= "      <link>" . htmlspecialchars($this->channelLink) . "</link>\n";
            $xmlValue .= "      <language>" . $this->channelLanguage . "</language>\n";
            $xmlValue .= "      <copyright>" . $this->channelCopyright . "</copyright>\n";
            $xmlValue .= "      <webMaster>" . $this->channelWebmaster . "</webMaster>\n";
            $xmlValue .= "      <lastBuildDate>" . $this->channellastBuildDate . "</lastBuildDate>\n";
            $xmlValue .= "      <generator>" . $this->channelGenerator . "</generator>\n";

            if ($this->versionRSS === '0.91') {
                $xmlValue .= "      <docs>http://backend.userland.com/rss091</docs>\n";
            }
            else{
                $xmlValue .= "      <docs>http://blogs.law.harvard.edu/tech/rss</docs>\n";
            }
        
                // Connect to the database
                $list = opendir("./data/");
                $count=0;
                while($get_list = readdir($list)) {
                    if ($get_list != "." && $get_list != ".." && $get_list != ".htaccess") {
                        
                        $filename = "./data/". $get_list;
                        $fileDate = filemtime($filename);
                        $fileModDate = date("D, d M Y H:i:s O",$fileDate);
                        $file = fopen ($filename, "r");
                        $buffer_size = 8192;
                        $summary = "";
                        
                        $xmlValue .= "          <item>\n";
                        $xmlValue .= "          <title>" . $get_list . "</title>\n";
                        $xmlValue .= "          <description>";

                            // read data and striped html tag from it
                            while (!feof ($file)) {
                                $line = fgetss ($file, $buffer_size);

                                // shorten a string to a certain length (400 char) at the most sensible point.
                                // If the string is already shorter than 400 char, it is returned unchanged.
                                // else if the string is more than 400 char, then
                                // if there's a ' ' (space) character near the end of the string, 
                                // the string is truncated after the last ' ' character.
                                // If the string is truncated, "....." is appended.

                                if (strlen($line) <= 400) { 
                                    $summary .= $line;                  // already shorter than 400 char
                                }
                                else {
                                    //$summary .= substr_replace($line,'.....',400,($buffer_size));
                                    
                                    $pos = strrpos($line," ");
                                    if ($pos>=396) {
                                        $line = substr($line,0,396);
                                        $pos = strrpos($line," ");
                                    }
                                    if ($pos>=400*0.4) {
                                        $summary .= substr($line,0,$pos).".....";
                                        break;
                                    }
                                }
                            } 
        
                        $xmlValue .= htmlspecialchars($summary);
                        $xmlValue .= "</description>\n";
                        $xmlValue .= "          <link>" . htmlspecialchars($this->channelLink) . "/index.php?show=" . $get_list . "</link>\n";
                        $xmlValue .= "          <pubDate>" . $fileModDate . "</pubDate>\n";
                        $xmlValue .= "      </item>\n";
                    $count++;
                    }
                }
                closedir($list);

            // Add the closing rss tag and return the value
            $xmlValue .= "  </channel>\n";
            $xmlValue .= "</rss>\n";
        }
        return $xmlValue;
    }
}
?>