<?php
/*----------------------------------------------------------------------------\
|                  JAF CMS - ...just another flat file CMS                    |
|-----------------------------------------------------------------------------|
|-----------------------------------------------------------------------------|
|                        Created by Salim "ph03y3nk"                          |
|               (Mail Contact : ph03y3nk@users.sourceforge.net)               |
|                For JAF CMS (http://jaf-cms.sourceforge.net/)                |
|-----------------------------------------------------------------------------|
|-----------------------------------------------------------------------------|
| JAF CMS - ...just another flat file CMS, is a Simple PHP Content Management |
| System (CMS). Consist of a powerfull set of PHP scripts, for small personal |
| homepage without database needed. Tested on Apache server 1.3.23 and PHP 4. |
|-----------------------------------------------------------------------------|
|-----------------------------------------------------------------------------|
|                   Copyright (c) 2004, Salim,SE. (ph03y3nk)                  |
|                                                                             |
|                             ___            ___                              |
|                            /\__\          /\__\                             |
|                           /:/ _/_        /:/ _/_                            |
|                          /:/ /\  \      /:/ /\  \                           |
|                         /:/ /::\  \    /:/ /::\  \                          |
|                        /:/_/:/\:\__\  /:/_/:/\:\__\                         |
|                        \:\/:/ /:/  /  \:\/:/ /:/  /                         |
|                         \::/ /:/  /    \::/ /:/  /                          |
|                          \/_/:/  /      \/_/:/  /                           |
|                            /:/  /         /:/  /                            |
|                            \/__/July,2004.\/__/                             |
|                             -Salims Softhouse-                              |
|                                                                             |
|-----------------------------------------------------------------------------|
|-----------------------------------------------------------------------------|
| This software is provided "as is", without warranty of any kind, express or |
| implied, including  but not limited  to the warranties of  merchantability, |
| fitness for a particular purpose and noninfringement. In no event shall the |
| authors or  copyright  holders be  liable for any claim,  damages or  other |
| liability, whether  in an  action of  contract, tort  or otherwise, arising |
| from,  out of  or in  connection with  the software or  the  use  or  other |
| dealings in the software.                                                   |
| - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - |
| This  software is  available under GNU GPL - The GNU General Public License |
| v2.  To use this software you must accept the license terms and conditions. |
| - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - |
| GPL - The GNU General Public License    http://www.gnu.org/licenses/gpl.txt |
| Permits anyone the right to use and modify the software without limitations |
| as long as proper  credits are given  and the original  and modified source |
| code are included. Requires  that the final product, software derivate from |
| the original  source or any  software  utilizing a GPL  component, such  as |
| this, is also licensed under the GPL license.                               |
| - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - |
| You should have received a copy of the GNU General Public License along     |
| with this program, if not, write to the Free Software Foundation, Inc., 59  |
| Temple Place, Suite 330, Boston, MA 02111-1307 USA                          |
|-----------------------------------------------------------------------------|
|-----------------------------------------------------------------------------|
| Created 01/07/2004 |-----------------------------------| Updated 24/04/2006 |
\----------------------------------------------------------------------------*/

 //csvfile.inc.php (table-xs v1.83) - (C) by Jack (tR) (http://www.jtr.de/scripting/php)
$csv_include=1;
class csvfile
/*
    The Data source is a CSV text file (comma separated values)

    All values are seperated by Doublequotes (") and commata (,)
    e.g: ("...","...","...")

    The first line contains the attributes (headings of the table)

*/
{

    // public class variables which can be modified
    var $name          = "";
    var $handle        = "";
    var $captions      = array();
    var $list_next_pos = 0;
    var $file_next_pos = 0;
    var $eol           = true;

/*

//--------------------------------------------------------------------------
//              I N T E R F A C E
//--------------------------------------------------------------------------

    // returns the captions of the table rows
    array get_captions( );

    // opens the data source
    boolean open( string mode );

    // closes the data source
    boolean close();

    // initializes the data source
    boolean init();

    // returns the number of table entries
    int entries();

    // returns an entry from the table
    get_entry( int pos, reference array rows );

    // returns the next entry from the table
    get_next_entry( reference array rows );

    // returns several successive table entries
    get_entrylist( int start, int stop, reference array entrylist );

    // appends an entry to the table
    append( array data );

    // looks for the first appearance of a date in the table
    find_entry( string data );

    // looks for the next appearance of a date in the table
    find_next_entry( string data );

    // changes an entry in the table
    change( int pos, array data );

    // removes an entry from the table
    delete( int pos )

    // inserts a (line-)entry to the table
    function insert ( int pos, array data )

    //returns true if reachs end of list
    eol()

*/


//--------------------------------------------------------------------------
//          Internal Help Functions
//--------------------------------------------------------------------------

    function clean_string( $str )
    // Task:    Removes all superflous seperators and characters from
    //          the string
    // Input:   $str   : a row, red from CSV-file, still containing artefacts
    //                   of comma seperation
    //
    // Output:  String without " (Double Quotes) at the begin and end
    //          (additionally all slash-coded chars will be decoded)
    {
        $str = trim( $str );
        $newlen = $strlen = strlen( $str );

        // Ignore quotes if string contains with
        if ( substr($str,0,1) == '"')
        {
            $start = 1;
            $newlen--;
        }
        else $start = 0;

        // ignore Quotes if string ends with
        if (substr( $str, $strlen-1, 1 ) == '"') { $newlen--; }

        // cut the "real" data from string !!!
        $str = substr( $str, $start, $newlen );

        $str = stripslashes( $str );    // decode slash-coded chars

        return $str;
    }


    function get_captions()
    // Task:   returns the captions of the table rows
    //
    // Input:  none
    //
    // Output: returns the table captions in $captions
    {
        // reads captions from the first line
        $line = fgets( $this->handle, 4096 );
        $tokens = explode( '","' , $line );

        $keys = array_keys( $tokens );
        foreach ($keys as $key)
        {
            $this->captions[$key] = $this->clean_string( $tokens[$key] );
        }
    }


//--------------------------------------------------------------------------
//          I M P L E M E N T A T I O N
//--------------------------------------------------------------------------

    function open( $mode )
    // opens the data source
    {
        if ( ! $this->handle = fopen( $this->name, $mode ) )
        {
            return false;
        }
        else
        {
            // lock file if opened for write mode
            if ( eregi( "a|w|\+", $mode ) )
            { flock( $this->handle, 2); }

            $this->eol = feof( $this->handle );
            return true;
        }
    }


    function close()
    // closes the data source
    {
//      flock( $this->handle, 3 );
        return fclose( $this->handle );
    }

    function init()
    // initializes the data source
    {
        if ( $this->open( "a+" ) && $this->close() )
        {
            return true;
        }
        return false;

        $this->list_next_pos = 0;
        $this->file_next_pos = 0;
    }

    function entries()
    // Task:   returns the number of table entries
    //
    // Input:  none
    //
    // Output: number of entries
    {
        $num_entries = 0;
        $this->open( "r" );

        // read captions from first line
        $this->get_captions();

        // ... and count all following lines
        while ( $line = fgets( $this->handle, 4096 ) )
        {
            $num_entries++;
        }
        $this->close();
        return $num_entries;
    }


    function get_entry( $pos, &$rows )
    // Task:   returns an entry from the table
    //
    // Input:  $pos     = number of the line from where to fetch the data
    //
    // Output: $rows    = array containing the entries
    {
        $this->open( "r" );

        // read table headings from the first line
        $this->get_captions();

        // skip all entries before start position
        $i=0;
        while ( ($i < $pos) && ($line = fgets( $this->handle, 4096 )))
        {
            $i++;
        }
        $line = fgets( $this->handle, 4096 );

        // keep current position in memory for get_next_entry
        $this->file_next_pos = ftell( $this->handle );
        $this->list_next_pos = $pos + 1;

        if ( feof( $this->handle ) ) { $this->eol = true; }

        $this->close();

        $tokens = explode( '","' , $line );

        $keys = array_keys( $tokens );
        reset( $this->captions );

        foreach ($keys as $key)
        {
            $cap = current( $this->captions );
            $rows[$cap] = $this->clean_string( $tokens[$key] );
            next( $this->captions );
        }
    }

    function get_next_entry( &$rows )
    // Task:   returns the next entry from the table
    //
    // Output: $rows    = array containing the entries
    {
        $this->open( "r" );

        //set to entry following last get_entry
        fseek( $this->handle, $this->file_next_pos );

        if ( $line = fgets( $this->handle, 4096 ) )
        { $this->list_next_pos++; }

        // keep current position in memory for get_next_entry
        $this->file_next_pos = ftell( $this->handle );

        if ( feof( $this->handle ) ) { $this->eol = true; }
        $this->close();

        $tokens = explode( '","' , $line );

        $keys = array_keys( $tokens );
        reset( $this->captions );

        foreach ($keys as $key)
        {
            $cap = current( $this->captions );
            $rows[$cap] = $this->clean_string( $tokens[$key] );
            next( $this->captions );
        }
    }


    function get_entrylist( $start, $stop, &$entrylist )
    // Task:   returns several successive table entries
    //
    // Input:  $start     = first entry to fetch
    //         $end       = last entry to fetch
    //
    // Output: $entrylist = two dimensional array containing the red lines/entries
    {
        $this->open( "r" );

        // Read table headings from the first line
        $this->get_captions();

        // Read all entries to the start position
        $i=0;
        while ( ($i < $start) && ($line = fgets( $this->handle, 4096 )))
        {
            $i++;
        }

        while ( ($i <= $stop) && ($line = fgets( $this->handle, 4096 )) )
        {
            $tokens = explode( '","' , $line );

            $keys = array_keys( $tokens );
            reset( $this->captions );

            foreach ($keys as $key)
            {
                $cap = current( $this->captions );
                $entrylist[$i][$cap] = $this->clean_string( $tokens[$key] );
                next( $this->captions );
            }

            $i++;
        }
        if ( feof( $this->handle ) ) { $this->eol = true; }
        $this->close();
    }


    function append( $data )
    // Task:  Appends an entry to the table
    //
    // Input: $data     = array with the data to save
    //
    {
        clearstatcache(); //...otherwise filesize stays constant!!!

        if ( filesize( $this->name ) == 0 )
        {
            $line = '';
            $this->open( "a+" );

            $keys = array_keys( $data );
            foreach ($keys as $key)
            {
                if (!empty( $line ))
                {
                    $line .= ',';
                }
                $line .= '"' . $key. '"';
            }

            fputs( $this->handle, $line."\n" );
            $this->close();
        }

        $this->open( "r" );
        $this->get_captions();
        $this->close();

        $line = '';
        $this->open( "a+" );

        $values = array_values( $this->captions );

        foreach ($values as $val)
        {
            if (!empty( $line ))
            {
                $line .= ',';
            }
            $line .= '"' . $data[$val]. '"';
        }

        fputs( $this->handle, $line."\n" );
        $this->close();
    }


    function find_entry( $data )
    // Task:   Searches for the first appearance of a date in the table
    //
    // Input:  $data = array with columns to find
    //
    {
        $entry = 0;
        $this->open( "r" );
        $this->get_captions();

        // for each row in table
        while ( $line = fgets( $this->handle, 4096 ) )
        {
            unset( $tokens );
            unset( $row ); $row = array();

            // read line and transfer csv-values into array $row

            $tokens = explode( '","' , $line );

            $keys = array_keys( $tokens );
            reset( $this->captions );

            foreach ($keys as $key)
            {
                $cap = current( $this->captions );
                $row[$cap] = $this->clean_string( $tokens[$key] );

                next( $this->captions );
            }

            $equal = true;

            $keys = array_keys( $data );
            foreach ($keys as $key)
            {
                if ( $data[$key] != $row[$key] )
                {
                    $equal = false;
                    break;
                }
            }

            if ( $equal )
            {
                break;
            }

            $entry++;
        }

        // keep current position in memory for get_next_entry
        $this->file_next_pos = ftell( $this->handle );

        if ( feof( $this->handle ) ) { $this->eol = true; }

        $this->close();
        $this->list_next_pos = $entry + 1;
        return $entry;
    }


    function find_next_entry( $data )
    // Task:   Searches for the next appearance of a date in the table
    //
    // Input:  $data    = array with colums to find
    //
    {
        $ok = false;
        $entry = $this->list_next_pos;
        $this->open( "r" );

        //set to entry following last get_entry
        fseek( $this->handle, $this->file_next_pos );

        // for each row in table
        while ( $line = fgets( $this->handle, 4096 ) )
        {
            unset( $tokens );
            unset( $row ); $row = array();

            // read line and transfer csv-values into array $row

            $tokens = explode( '","' , $line );

            $keys = array_keys( $tokens );
            reset( $this->captions );

            foreach ($keys as $key)
            {
                $cap = current( $this->captions );
                $row[$cap] = $this->clean_string( $tokens[$key] );

                next( $this->captions );
            }

            $equal = true;

            $keys = array_keys( $data );
            foreach ($keys as $key)
            {
                if ( $data[$key] != $row[$key] )
                {
                    $equal = false;
                    break;
                }
            }

            if ( $equal )
            {
                break;
            }

            $entry++;
        }

        // keep current position in memory for get_next_entry
        $this->file_next_pos = ftell( $this->handle );
        $this->list_next_pos = $entry++;

        if ( feof( $this->handle ) ) { $this->eol = true; }

        $this->close();
        return $entry;
    }


    function change( $pos, $data )
    // Task:   Changes a line in the table
    //
    // Input:  $pos   = Position of the element
    //         $data  = array containing the data to save
    //
    {
        $num_of_entries = $this->entries();

        if ( filesize( $this->name ) == 0 )
        {
            $this->append( $data );
        }

        $this->open( "r" );
        $this->get_captions();
        $this->close();

        // Komplette Datei zeilenweise einlesen
        $entrylist = file( $this->name );

        $newline = '';

        $values = array_values( $this->captions );
        foreach ($values as $val)
        {
            if (!empty( $newline ))
            {
                $newline .= ',';
            }
            $newline .= '"' . $data[$val]. '"';
        }
        $newline .= "\n";
        $entrylist[$pos+1]=$newline;

        $this->open( "w" );
        fwrite( $this->handle, ereg_replace( "\r", "", implode( "", $entrylist ) ) );

        $this->close();
    }


    function delete( $pos )
    // Task:  Removes a line from the table
    //
    // Input: $pos  = Position of the Element
    //
    {
        $num_of_entries = $this->entries();

        if ( filesize( $this->name ) != 0 )
        {

            // Komplette Datei zeilenweise einlesen
            $entrylist = file( $this->name );

            unset( $entrylist[$pos+1] );

            $this->open( "w" );
            fwrite( $this->handle, ereg_replace( "\r", "", implode( "", $entrylist ) ) );

            $this->close();
        }
    }


    function insert ( $pos, $data )
    // Task:  Removes a line from the table
    //
    // Input: $pos  = Position of the Element
    //
    {
        $num_of_entries = $this->entries();

        if ( filesize( $this->name ) == 0 )
        {
            $this->append( $data );
        }
        else
        {
            $newline = '';

            $values = array_values( $this->captions );
            foreach ($values as $val)
            {
                if (!empty( $newline ))
                {
                    $newline .= ',';
                }
                $newline .= '"' . $data[$val]. '"';
            }
            $newline .= "\n";

            $this->open( "r" );
            $this->get_captions();
            $this->close();

            $this->open( "r" );
            $captionline = fgets( $this->handle, 4096 );
            $entrylist = array();
            $entrylist[0] = $captionline;
            $pos++;

            // Datei bis zur Einfgeposition zeilenweise einlesen
            $i = 1;
            while ($i < $pos )
            {
                $entrylist[$i] = fgets( $this->handle, 4096 );
                $i++;
            }

            $entrylist[$i]=$newline;
            $i++;

            while ( $entrylist[$i] = fgets( $this->handle, 4096 ) )
            {
                $i++;
            }
            $this->close();

            $this->open( "w" );
            fwrite( $this->handle, ereg_replace( "\r", "", implode( "", $entrylist ) ) );
            $this->close();
        }
    }


    function eol()
    // Task:  Removes a line from the table
    //
    // Input: $pos  = Position of the Element
    //
    {
        return $this->eol;
    }

}

?>