<?xml version="1.0" encoding="iso-8859-1"?>
<xsl:stylesheet version="1.0"
  xmlns:xsl = "http://www.w3.org/1999/XSL/Transform"
  xmlns:sy = "http://purl.org/rss/1.0/modules/syndication/"
  xmlns:rss = "http://purl.org/rss/1.0/"
  xmlns:Wombie = "./"
  xmlns = "http://www.w3.org/1999/xhtml"
>

<!--
name            : rss.xsl
version         : 1.0
creationDate    : 14/05/2006
author          : ph03y3nk@users.sourceforge.net
copyright       : GNU/GPL
description     : XSL stylesheet for RSS0.91 and RSS2.0 output 
-->


<xsl:output method="html" />
<xsl:template match="/">
<html>
    <head>
      <title>RSS feeds for <xsl:value-of select="/rss/channel/title"/></title>
      <xsl:element name="meta">
        <xsl:attribute name="content-type">text/html; charset=iso-8859-1</xsl:attribute>
      </xsl:element>
      <xsl:element name="link">
        <xsl:attribute name="rel">stylesheet</xsl:attribute>
        <xsl:attribute name="href">./templates/rss_feeds/rss.css</xsl:attribute>
        <xsl:attribute name="type">text/css</xsl:attribute>
        <xsl:attribute name="title">mainlook</xsl:attribute>
      </xsl:element>
      <xsl:element name="link">
        <xsl:attribute name="rel">alternate</xsl:attribute>
        <xsl:attribute name="href">./templates/rss_feeds/rss.xsl</xsl:attribute>
        <xsl:attribute name="type">application/rss+xml</xsl:attribute>
        <xsl:attribute name="title">rss</xsl:attribute>
      </xsl:element>
    
    </head>

<body>

    <div class="meantForReader">Don't panic!!! This is a RSS feed. This web page is
    actually a XML data file that is meant to be read by RSS reader programs (news aggregator). 
    It is not intended to be read through a browser, although we've used XSL stylesheet that transforms the data into something nice for browsers.
    <p>Add <a href="{/rss/channel/link}/backend.php">this link</a> into your news aggregator so you can receive up to date information about this feed.</p>
    </div>

<blockquote class='aboutThisFeed'>
        <p><em>Feed update:</em>
          <xsl:value-of select="/rss/channel/lastBuildDate"/>
        </p>
        <p><em>Copyright:</em>
          <xsl:value-of select="/rss/channel/copyright" />
        </p>
        <p><em>Site admin:</em>
          <xsl:value-of select="/rss/channel/webMaster" />
        </p>
        <p><em>Language:</em>
          <xsl:value-of select="/rss/channel/language" />
        </p>
        <p><em>ReadMe:</em>
          <xsl:value-of select="/rss/channel/docs" />
        </p>
</blockquote>


<h1 class="feedtitle"><a href="{/rss/channel/link}">
  <xsl:value-of select="/rss/channel/title"/>
</a></h1>

<xsl:for-each select="/rss/channel/description">
  <xsl:if test=". != /rss/channel/title" >
  <!-- no point in printing them both if they're the same -->
    <p class='desc'><xsl:value-of select="."/></p>
  </xsl:if>
</xsl:for-each>


<xsl:variable name="C" select="count(/rss/channel/item)" />
<p class='leadIn'>
  <xsl:choose>
    <xsl:when test="$C = 0" >No items </xsl:when>
    <xsl:when test="$C = 1" >The only item </xsl:when>
    <xsl:otherwise>Total <xsl:value-of select="$C" /> items </xsl:otherwise>
  </xsl:choose>
  currently in this feed:
</p>



<dl class='Items'>

<xsl:if test='$C = 0'>  <dt>(Empty)</dt> </xsl:if>

<xsl:for-each select="/rss/channel/item">

<dt>

  <a href="{link}">
    <xsl:if test="position() &lt; 10">
      <xsl:attribute name='accesskey'><xsl:value-of select="position()" /></xsl:attribute>
    </xsl:if>

    <xsl:choose>
      <xsl:when test="not(title) or title = ''" ><em>(No title)</em></xsl:when>
      <xsl:otherwise><xsl:value-of select="title"/></xsl:otherwise>
    </xsl:choose>
  </a>
</dt>

<xsl:if test="description" >
  <dd name="decodeme">
  <xsl:value-of disable-output-escaping="yes" select="description" /></dd>
</xsl:if>
</xsl:for-each>
</dl>



<!-- The bottom-of-page options: -->
<p class='end'>[<a href="./">Back to Mainpage</a>]</p>


<p class="badcss">
Hm, you're apparently using a browser that doesn't
support stylesheets properly<em style="display: none">, or at all</em>.
You should really think about using
<a href="http://www.mozilla.org/products/firefox/">Firefox</a>
instead.
</p>


</body>
</html>
</xsl:template>
</xsl:stylesheet>